> For the complete documentation index, see [llms.txt](https://docs.exads.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.exads.com/publishers/vast/vast-wrapper.md).

# VAST Wrapper Tag

As a Publisher, you receive a VAST wrapper tag response when your video player requests an ad that redirects to a secondary VAST response.

## XML Example

{% code expandable="true" %}

```xml
<?xml version="1.0" encoding="UTF-8"?>
<VAST version="3.0">
    <Ad id="1111111">
        <Wrapper>
            <AdSystem>EXADS</AdSystem>
            <VASTAdTagURI><![CDATA[https://myotheradserver.com/xml?cid=1111111]]></VASTAdTagURI>
            <Impression id="exotr">
                <![CDATA[https://mytrackingsolution.com/vregister.php?a=vimp&tracking_event=impression&idzone=22222&data=abcd]]></Impression>
            <Error>
                <![CDATA[https://mytrackingsolution.com/vregister.php?a=vview&errorcode=[ERRORCODE]&idzone=22222]]></Error>
            <Creatives>
                <Creative sequence="1" id="12345">
                    <Linear>
                        <TrackingEvents>
                            <Tracking id="prog_1" event="progress" offset="00:00:10.000">
                                <![CDATA[https://mytrackingsolution.com/vregister.php?a=vview&tracking_event=progress&progress=00:00:10.000&idzone=22222&data=abcd]]></Tracking>
                            <Tracking id="custom_1" event="creativeView"><![CDATA[https://mytrackingsolution.com/vregister.php?a=vview&tracking_event=creativeView&idzone=22222&data=abcd]]></Tracking>
                        </TrackingEvents>
                        <VideoClicks>
                            <ClickTracking>
                                <![CDATA[https://mytrackingsolution.com/click.php?data=abcd]]></ClickTracking>
                        </VideoClicks>
                    </Linear>
                </Creative>
            </Creatives>
        </Wrapper>
    </Ad>
</VAST>
```

{% endcode %}

## Properties <a href="#properties" id="properties"></a>

| Option                                   | Explanation                                                                                                                                                                                                                                                                                                      |
| ---------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `<?xml version="1.0" encoding="UTF-8"?>` | XML prolog with defined version and encoding.                                                                                                                                                                                                                                                                    |
| `VASTAdTagURI`                           | Element is used to provide a URI to a secondary VAST response. This secondary response may be another Wrapper, but eventually a VAST wrapper must return an `<InLine>` ad. Version 3 doesn't limit the number of Wrapper redirections, but from Version 4, a maximum of 5 Wrapper VAST redirections are allowed. |
| `VideoClicks`                            | Element which is used to specify what the video player should do if the user clicks directly within the video player frame while the ad is being displayed. When a `<VideoClicks>` element is provided, it contains a single child `<ClickTracking>` element with URI (or `<ClickThrough>` in case of VAST Tag). |
| `ClickTracking`                          | Element is used to track the `clickthrough` when the creative file handles the `clickthrough`.                                                                                                                                                                                                                   |

## Supported Tracking **Events** <a href="#supported-tracking-events-for-creative--linear--trackingevents--tracking" id="supported-tracking-events-for-creative--linear--trackingevents--tracking"></a>

{% hint style="info" %}
&#x20;These events apply to `Creative` > `Linear` > `TrackingEvents` > `Tracking` .
{% endhint %}

[VAST Custom Tracking Events](/publishers/vast/custom-tracking-urls.md#supported-tracking-events-tracking_event-for-creative-linear-trackingevents-tracking-in-vast-tag)

| Event            | Explanation                                              |
| ---------------- | -------------------------------------------------------- |
| creativeView     | Triggered when the creative is displayed.                |
| start            | Triggered when the Linear ad starts playing.             |
| midpoint         | Triggered when the Linear ad reaches the middle point.   |
| firstQuartile    | Triggered when the Linear ad reaches the first quartile. |
| thirdQuartile    | Triggered when the Linear ad reaches the third quartile. |
| complete         | Triggered when the Linear ad reaches the end point.      |
| mute             | Triggered when the Linear ad is muted.                   |
| unmute           | Triggered when the Linear ad is unmuted.                 |
| pause            | Triggered when the Linear ad is paused.                  |
| rewind           | Triggered when the Linear ad is rewound.                 |
| resume           | Triggered when the Linear ad is resumed.                 |
| fullscreen       | Triggered when the Linear ad is in fullscreen.           |
| expand           | Triggered when the Linear ad is expanded.                |
| collapse         | Triggered when the Linear ad is collapsed.               |
| acceptInvitation | Triggered when the Linear ad is accepted.                |
| close            | Triggered when the Linear ad is closed.                  |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.exads.com/publishers/vast/vast-wrapper.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
